Attribute VB_Name = "mFunctions"
' Code & Research by clearscreen and telatoro.
' If you plan on using this code to create a private server, please keep our credits in it.
' For any (serious!!!) questions you can always mail me at clearscreen@lycantrope.com

' Useful functions
Public Declare Sub CopyMemory Lib "kernel32" Alias _
"RtlMoveMemory" (pDst As Any, pSrc As Any, _
ByVal ByteLen As Long)
Private Declare Function GetPrivateProfileString Lib "kernel32.dll" Alias "GetPrivateProfileStringA" ( _
    ByVal lpApplicationName As String, _
    ByVal lpKeyName As Any, _
    ByVal lpDefault As String, _
    ByVal lpReturnedString As String, _
    ByVal nSize As Long, _
    ByVal lpFileName As String) As Long

' Sleep defines
Private Const QS_KEY = &H1
Private Const QS_MOUSEMOVE = &H2
Private Const QS_MOUSEBUTTON = &H4
Private Const QS_POSTMESSAGE = &H8
Private Const QS_TIMER = &H10
Private Const QS_PAINT = &H20
Private Const QS_SENDMESSAGE = &H40
Private Const QS_HOTKEY = &H80
Private Const QS_MOUSE = (QS_MOUSEMOVE Or QS_MOUSEBUTTON)
Private Const QS_INPUT = (QS_MOUSE Or QS_KEY)
Private Const QS_ALLEVENTS = (QS_INPUT Or QS_POSTMESSAGE Or QS_TIMER Or QS_PAINT Or QS_HOTKEY)
Private Const QS_ALLINPUT = (QS_SENDMESSAGE Or QS_PAINT Or QS_TIMER Or QS_POSTMESSAGE Or QS_MOUSEBUTTON Or QS_MOUSEMOVE Or QS_HOTKEY Or QS_KEY)
Private Declare Function GetTickCount Lib "kernel32" () As Long
Private Declare Function MsgWaitForMultipleObjects Lib "user32" (ByVal nCount As Long, pHandles As Long, ByVal fWaitAll As Long, ByVal dwMilliseconds As Long, ByVal dwWakeMask As Long) As Long

Public Function Wait(ByVal ms As Long)

'Note: time is in seconds not milliseconds
    Dim start As Long, timeRemaining As Long, timeNow As Long
    start = GetTickCount()
    timeRemaining = ms * 1000
    Do
        MsgWaitForMultipleObjects 0, 0, 0, timeRemaining, QS_ALLINPUT
        timeNow = GetTickCount()
        If timeNow - start >= timeRemaining Then
            Exit Function
        ElseIf timeNow < start Then
            start = timeNow
        End If
        timeRemaining = timeRemaining - (timeNow - start)
        start = timeNow
        DoEvents
    Loop
    
End Function

Public Function LoadData(pFileName As String) As String

On Error GoTo errhandle
    Dim lFile As Long
    Dim lLargo As Long
    Dim lData As String
    
    lFile = FreeFile()
    lLargo = FileSystem.FileLen(pFileName)
    lData = Space(lLargo)
    
    Open pFileName For Binary As #lFile
        Get #lFile, , lData
    Close #lFile
    
    LoadData = lData
errhandle:
'Fixit

End Function

Public Function Ascii2Hex(pAscii As String) As String
    
    Dim i As Integer
    Dim nAscii As String
    
    For i = 1 To Len(pAscii)
        If Len(Hex(Asc(Mid(pAscii, i, i + 1)))) = 1 Then
            nAscii = nAscii & "0" & Hex(Asc(Mid(pAscii, i, i + 1)))
        Else
            nAscii = nAscii & Hex(Asc(Mid(pAscii, i, i + 1)))
        End If
    Next i
    
    Ascii2Hex = nAscii
    
End Function

Public Function Dec2Hex(pDec As Integer) As String

    Dec2Hex = Hex(Int(pDec))
    
End Function

Public Function EncryptString(pString As String, pSeed As String) As String

    aKey() = cv_BytesFromHex(pSeed)
    blf_Initialise aKey, 8
    abPlain = cv_BytesFromHex(pString)
    abCipher = blf_BytesRaw1(abPlain, bEncrypt:=True)
    EncryptString = cv_HexFromBytes(abCipher)
    
End Function

Public Function DecryptString(pString As String, pSeed As String) As String

    aKey() = cv_BytesFromHex(pSeed)
    blf_Initialise aKey, 8
    abPlain = cv_BytesFromHex(pString)
    abCipher = blf_BytesRaw1(abPlain, bEncrypt:=False)
    DecryptString = cv_HexFromBytes(abCipher)
    
End Function

Function ConvierteWStrLong(pCadena As String) As Long

    Dim lCadena As String
    Dim lValor As Double
    
    lValor = 0
    For i = 1 To Len(pCadena)
        lValor = lValor + Asc(Mid(pCadena, i, 1)) * (256 ^ (i - 1))
    Next i
    
    
    ConvierteWStrLong = UnsignedToLong(lValor)
    
End Function

Public Function CopyLongStr(ByRef pSource As Long) As String

    Dim lArray(1 To 4) As Byte
    Dim lTarget As String

    CopyMemory lArray(1), ByVal VarPtr(pSource), 4
    
    lTarget = ""
    For i = 1 To 4
        lTarget = lTarget & Chr(lArray(i))
    Next i
    
    CopyLongStr = lTarget
    
End Function

Public Function iniGetStr(value As String, Section As String, Pathname As String, Optional pShowMsgBox As Boolean = True) As String

    Dim defaultstr As String  ' going to receive the value read from the INI file
    Dim slength As Long  ' going to receive length of the returned string
    defaultstr = Space(255)  ' provide enough room for the function to put the value into the buffer
    slength = GetPrivateProfileString(Section, value, "(error)", defaultstr, 255, Pathname)
    defaultstr = Left(defaultstr, slength)  ' extract the returned string from the buffer
        If defaultstr = "(error)" Then ' we have a problem
            defaultstr = "(error)"
            iniGetStr = defaultstr
            'Dont need below line in if you don't like it!
            'Just to tell you by msgbox it messed up.
            If pShowMsgBox Then
                'Fixit
            End If
        Else ' no problems!
            iniGetStr = defaultstr  ' assign String from INI file to INI_getString
        End If
        
End Function
