Attribute VB_Name = "mServerlist"
' Code & Research by clearscreen and telatoro.
' If you plan on using this code to create a private server, please keep our credits in it.
' For any (serious!!!) questions you can always mail me at clearscreen@lycantrope.com

' Serverlisting packets
Public sListPaq(16) As String

Public Function InitializeServerlistPackets()
    'Our seed from here; 5B814ADAC5E30DEB
    sListPaq(0) = cv_StringFromHex("110000500000065B814ADAC5E30DEB6300000001000000") 'Seed
    
    sListPaq(1) = cv_StringFromHex("1000012000000D004761746577617953657276657200")
    sListPaq(2) = cv_StringFromHex("05000D60000001010005200B000D60000000010001CF02050000000205000D60000001010005600C000D60000000030001CE0201030200023C")
    sListPaq(3) = cv_StringFromHex("05000D60000001010000A102000D6000000001")
    sListPaq(4) = LoadData("data/server/serverlist") 'Load serverlist data from file
    
    '[Default responses]. (02 = crash)
    sListPaq(6) = cv_StringFromHex("020002A100000205") ' Full server (not used)
    sListPaq(7) = cv_StringFromHex("020002A100000201") ' Authentication failed
    sListPaq(8) = cv_StringFromHex("020002A100000203") ' User already connected
    sListPaq(9) = cv_StringFromHex("020002A100000204") ' Failed connection (C5)
    sListPaq(10) = cv_StringFromHex("020002A100000206") ' Failed connection (C7)
    sListPaq(11) = cv_StringFromHex("020002A100000207") ' Failed connection (C8)
    sListPaq(12) = cv_StringFromHex("020002A100000208") ' IP Access Limit Exceeded
    sListPaq(13) = cv_StringFromHex("020002A100000209") ' Error 0
    sListPaq(14) = cv_StringFromHex("020002A10000020A") ' Only 18+ age allowed
    sListPaq(15) = cv_StringFromHex("020002A10000020B") ' Only 12+ age allowed
    sListPaq(16) = cv_StringFromHex("020002A10000020C") ' 18+ not allowed on teen server
    
    'Calculate IP Address
    Dim tIP() As String
    tIP() = Split(sIP, ".")
    sIP = ""
    For i = 0 To 3
        While Len(tIP(i)) < 3
            tIP(i) = "0" & tIP(i)
        Wend
        sIP = sIP & "." & tIP(i)
    Next i
    sIP = Mid(sIP, 2)
    
    'Calculate Port
    pDec = Dec2Hex(sPort)
    If Len(pDec) < 4 Then
        While Len(pDec) < 4
            pDec = "0" & pDec
        Wend
    End If
    pDec = Mid(pDec, 3, 2) & Mid(pDec, 1, 2)
    
    'Generate IP/Port packet
    sListPaq(5) = cv_StringFromHex("1880") & cv_StringFromHex(EncryptString("02A1000001BD0000000F00" & Ascii2Hex(sIP) & pDec & "00000000", bSeed))
End Function

Public Function CheckLogin(data As String)

    Dim user, pass, filename, filepass As String
    
    user = cv_StringFromHex(Mid(dData, 15, Val("&H" & Mid(dData, 11, 2)) * 2)) 'Extract user
    pass = cv_StringFromHex(Mid(dData, 19 + (Len(user) * 2), Val("&H" & Mid(dData, 15 + (Len(user) * 2), 2)) * 2)) 'Extract pass
    filename = "data\accounts\" & user & ".dat"
    
    If FileSystem.Dir(filename) = "" Then
        'Authentication failed, sorry. (no such user)
        frmMain.wSock(1).SendData sListPaq(7)
        Exit Function
    End If
    
    filepass = iniGetStr("pass", "account", "data\accounts\" & user & ".dat")
    fileacc = iniGetStr("accfile", "account", "data\accounts\" & user & ".dat")
    If pass = filepass Then 'Allow user :)
        sGamePaq(5) = LoadData("data\accounts\" & fileacc) 'Define accfile
        frmMain.wSock(1).SendData sListPaq(5) 'Send 127.0.0.1/15780 so user can continue
    Else
        'Authentication failed, sorry. (password wrong)
        frmMain.wSock(1).SendData sListPaq(7)
    End If

    'wSock(1).SendData sListPaq(5) 'Server full!
End Function
